--[[-------------------------------------------------------------
MACIULXOCHITL                                                   -
render.lua                                                      -
Temporary ugly sample rendering :(                              -
]]---------------------------------------------------------------

-- Update sample buffer values / is observable better solution ? /

function write_info_to_sample(sample, instrument)
  if sample then
    sample.name = tmp.SAMPLE_NAME
    instrument.name = tmp.INSTRUMENT_NAME
    sample.beat_sync_enabled = tmp.SAMPLE_BEAT_SYNC_ENABLED
    sample.beat_sync_lines = tmp.SAMPLE_BEAT_SYNC_LINES
    sample.beat_sync_mode = tmp.SAMPLE_BEAT_SYNC_MODE
    sample.loop_mode = tmp.SAMPLE_LOOP_MODE
    sample.panning = tmp.SAMPLE_PANNING
    sample.volume = tmp.SAMPLE_VOLUME
    sample.transpose = tmp.SAMPLE_TRANSPOSE
    sample.fine_tune = tmp.SAMPLE_FINE_TUNE
    sample.interpolation_mode = tmp.SAMPLE_INTERPOLATION_MODE
    sample.oversample_enabled = tmp.SAMPLE_OVERSAMPLE_ENABLED
    sample.new_note_action = tmp.SAMPLE_NEW_NOTE_ACTION
    sample.oneshot = tmp.SAMPLE_ONESHOT
    sample.mute_group = tmp.SAMPLE_MUTE_GROUP
    sample.autoseek = tmp.SAMPLE_AUTOSEEK
    sample.autofade = tmp.SAMPLE_AUTOFADE
  end
end

-- Read sample buffer values for saving 

function read_info_from_sample(sample, instrument)
  if sample then
    tmp.SAMPLE_NAME = sample.name
    tmp.INSTRUMENT_NAME = instrument.name
    tmp.SAMPLE_BEAT_SYNC_ENABLED = sample.beat_sync_enabled
    tmp.SAMPLE_BEAT_SYNC_LINES = sample.beat_sync_lines
    tmp.SAMPLE_BEAT_SYNC_MODE = sample.beat_sync_mode
    tmp.SAMPLE_LOOP_MODE = sample.loop_mode
    tmp.SAMPLE_LOOP_RELEASE = sample.loop_release
    tmp.SAMPLE_LOOP_START = sample.loop_start
    tmp.SAMPLE_LOOP_END = sample.loop_end
    tmp.SAMPLE_PANNING = sample.panning
    tmp.SAMPLE_VOLUME = sample.volume
    tmp.SAMPLE_TRANSPOSE = sample.transpose
    tmp.SAMPLE_FINE_TUNE = sample.fine_tune
    tmp.SAMPLE_INTERPOLATION_MODE = sample.interpolation_mode
    tmp.SAMPLE_OVERSAMPLE_ENABLED = sample.oversample_enabled
    tmp.SAMPLE_NEW_NOTE_ACTION = sample.new_note_action
    tmp.SAMPLE_ONESHOT = sample.oneshot
    tmp.SAMPLE_MUTE_GROUP = sample.mute_group
    tmp.SAMPLE_AUTOSEEK = sample.autoseek
    tmp.SAMPLE_AUTOFADE = sample.autofade
  end
end

--[[-------------------------------------------------------------
Paint magic , for now one ugly loop                             -
]]---------------------------------------------------------------

function redraw_sample(info_for_render) 

  collectgarbage("stop")  --< this has no effect for speed 

  math.randomseed(os.time())

  local new_sample = nil
  local new_buffer = nil
  local instrument = renoise.song().selected_instrument
  MAIN_INSTRUMENT = instrument


  -- this is hack for now, only one sample is permited
  -- at the moment

  if info_for_render == "new_patch" or info_for_render == "new_start" then

    -- if new patch is loaded delete all samples

    while table.getn(instrument.samples) > 0 do
      --print("Sampl vymazán")
      instrument:delete_sample_at(1)
    end

    -- and create new one

    new_sample = instrument:insert_sample_at(1)
    MAIN_SAMPLE = new_sample
    write_info_to_sample(new_sample, instrument)
    --print("Nový sampl vytvořen " .. tostring(info_for_render))
    info_for_render = false

  else
  
    if table.getn(instrument.samples) > 0 then
      new_sample = instrument:sample(1)
      MAIN_SAMPLE = new_sample
      read_info_from_sample(new_sample, instrument)
      write_info_to_sample(new_sample, instrument)
      --print("Používám stejný sampl ..")
    else
      --print("žádný sampl..")
    end
  end
  MAIN_SAMPLE = new_sample

  -- načti informace ze sample bufferu
  local new_buffer = new_sample.sample_buffer

  -- jestliže má sample buffer stejné hodnoty jako ten předešlý
  -- čili nebyla změněna jeho délka, samplrejt, bitová hloubka nebo
  -- počet kanálů použij již vytvořený buffer

  if new_buffer.has_sample_data
    and new_buffer.number_of_frames == tmp.SAMPLE_FRAMES
    and new_buffer.sample_rate == def.SAMPLE_FREQUENCY
    and new_buffer.bit_depth == def.SAMPLE_BIT_DEPTH
    and new_buffer.number_of_channels == def.SAMPLE_CHANNELS
  
  then
  
    --print("Používám nezměněný sample buffer")
  
  else
  
    -- pokud neplatí podmínky uvedené výše tak vytvářím nový sample buffer
    -- dle podmínek v globálních proměnných

    if
    
      tmp.SAMPLE_FRAMES > 0 and not new_buffer:create_sample_data(def.SAMPLE_FREQUENCY,
                                                                  def.SAMPLE_BIT_DEPTH,
                                                                  def.SAMPLE_CHANNELS,
                                                                  tmp.SAMPLE_FRAMES)
    
    then
    
      renoise.app():show_error("Error during sample creation!")
      renoise.song():undo()
    
      return
    
    else
    
      --print("Byl vytvořen nový změněný sample buffer")
      write_info_to_sample(MAIN_SAMPLE, MAIN_INSTRUMENT)
    
    end
  
  end

  new_buffer:prepare_sample_data_changes()

  local math_buffer = MATH_BUFFER

  -- if we just applying some of the gods to our wave
  -- we dont need to calculate wave again, just use old one
  -- and apply envelope

  if RECALCULATE then

    local val_1 = 0
    local val_2 = 0
    local val_3 = 0
    local result = 0

    MAX_VALUE = -9999.0
    MIN_VALUE = 9999.0

    math_buffer = {}
    local sin = math.sin
    local random = math.random
    local pi = math.pi

    for frame_in_buffer=1, tmp.SAMPLE_FRAMES do
    
      -- create and distort waves OSC1 is ON forever
 
      if tmp.SAMPLE_TYPE_1 == 1 then
        val_1 = OSC1:simple_saw(frame_in_buffer, tmp.SAMPLE_FRAMES)
      elseif tmp.SAMPLE_TYPE_1 == 2 then
        val_1 = OSC1:simple_sine(frame_in_buffer, tmp.SAMPLE_FRAMES)
      elseif tmp.SAMPLE_TYPE_1 == 3 then
        val_1 = OSC1:simple_square(frame_in_buffer, tmp.SAMPLE_FRAMES)
      elseif tmp.SAMPLE_TYPE_1 == 4 then
        val_1 = OSC1:simple_triangle(frame_in_buffer, tmp.SAMPLE_FRAMES)
      elseif tmp.SAMPLE_TYPE_1 == 5 then
        val_1 = OSC1:additive_saw(frame_in_buffer, tmp.SAMPLE_FRAMES)
      elseif tmp.SAMPLE_TYPE_1 == 6 then
        val_1 = OSC1:additive_square(frame_in_buffer, tmp.SAMPLE_FRAMES)
      elseif tmp.SAMPLE_TYPE_1 == 7 then
        val_1 = OSC1:additive_tan(frame_in_buffer, tmp.SAMPLE_FRAMES)
      end

      result = val_1


      -- If operation is not none calculate second oscilator

      if tmp.OP1 > 1 or OSC2.modulate_amp or OSC2.modulate_freq or OSC2.modulate_phase then 

        if tmp.SAMPLE_TYPE_2 == 1 then
          val_2 = OSC2:simple_saw(frame_in_buffer, tmp.SAMPLE_FRAMES, val_1)
        elseif tmp.SAMPLE_TYPE_2 == 2 then
          val_2 = OSC2:simple_sine(frame_in_buffer, tmp.SAMPLE_FRAMES, val_1)
        elseif tmp.SAMPLE_TYPE_2 == 3 then
          val_2 = OSC2:simple_square(frame_in_buffer, tmp.SAMPLE_FRAMES, val_1)
        elseif tmp.SAMPLE_TYPE_2 == 4 then
          val_2 = OSC2:simple_triangle(frame_in_buffer, tmp.SAMPLE_FRAMES, val_1)
        elseif tmp.SAMPLE_TYPE_2 == 5 then
          val_2 = OSC2:additive_saw(frame_in_buffer, tmp.SAMPLE_FRAMES, val_1)
        elseif tmp.SAMPLE_TYPE_2 == 6 then
          val_2 = OSC2:additive_square(frame_in_buffer, tmp.SAMPLE_FRAMES, val_1)
        elseif tmp.SAMPLE_TYPE_2 == 7 then
          val_2 = OSC2:additive_tan(frame_in_buffer, tmp.SAMPLE_FRAMES, val_1)
        end


        -- add some modulation between waves

        if tmp.OP1 == 2 then
          result = result + val_2
        elseif tmp.OP1 == 3 then
          result = result - val_2
        elseif tmp.OP1 == 4 then
          result = result * val_2
        elseif tmp.OP1 == 5 then
          result = result / val_2
        elseif tmp.OP1 == 6 then
          if result < val_2 then 
            result=result
          else
            result=val_2
          end
        elseif tmp.OP1 == 7 then
          if result > val_2 then 
            result=result
          else 
            result=val_2
          end
        elseif tmp.OP1 == 8 then
          result = result % val_2
        else
          result = val_2
        end

      end
      
      
      -- if operation one and operation two is not none sum waves

      if tmp.OP1 > 1 and tmp.OP2 > 1 or OSC3.modulate_freq or OSC3.modulate_amp or OSC3.modulate_phase then

        if tmp.SAMPLE_TYPE_3 == 1 then
          val_3 = OSC3:simple_saw(frame_in_buffer, tmp.SAMPLE_FRAMES, result)
        elseif tmp.SAMPLE_TYPE_3 == 2 then
          val_3 = OSC3:simple_sine(frame_in_buffer, tmp.SAMPLE_FRAMES, result)
        elseif tmp.SAMPLE_TYPE_3 == 3 then
          val_3 = OSC3:simple_square(frame_in_buffer, tmp.SAMPLE_FRAMES, result)
        elseif tmp.SAMPLE_TYPE_3 == 4 then
          val_3 = OSC3:simple_triangle(frame_in_buffer, tmp.SAMPLE_FRAMES, result)
        elseif tmp.SAMPLE_TYPE_3 == 5 then
          val_3 = OSC3:additive_saw(frame_in_buffer, tmp.SAMPLE_FRAMES, result)
        elseif tmp.SAMPLE_TYPE_3 == 6 then
          val_3 = OSC3:additive_square(frame_in_buffer, tmp.SAMPLE_FRAMES, result)
        elseif tmp.SAMPLE_TYPE_3 == 7 then
          val_3 = OSC3:additive_tan(frame_in_buffer, tmp.SAMPLE_FRAMES, result) 
        end


        if tmp.OP2 == 2 then
          result = result + val_3
        elseif tmp.OP2 == 3 and tmp.OP1 > 1 then
          result = result - val_3
        elseif tmp.OP2 == 4 and tmp.OP1 > 1 then
          result = result * val_3
        elseif tmp.OP2 == 5 and tmp.OP1 > 1 then
          result = result / val_3
        elseif tmp.OP2 == 6 then
          if result < val_3 then 
            result=result
          else 
            result=val_3
          end
        elseif tmp.OP2 == 7 then
          if result > val_3 then 
            result=result 
          else 
            result=val_3 
          end
        else
          result = val_3
        end

      end
      
      
      -- Add some random noise to our wave

      if tmp.SAMPLE_NOISE_BOOL then
        if random() > 0.5 then
          result = result + (random() / (def.SAMPLE_MAX_NOISE - tmp.SAMPLE_NOISE_AMOUNT +0.1))
        else
          result = result - (random() / (def.SAMPLE_MAX_NOISE - tmp.SAMPLE_NOISE_AMOUNT +0.1))
        end
      end

      -- Prepare values for wave normalization

      if result > MAX_VALUE then
        MAX_VALUE = result
      end
    
      if result < MIN_VALUE then
        MIN_VALUE = result
      end

      -- Add result to buffer

      math_buffer[frame_in_buffer] = result

    end
  end
  
  -- i dont know why i put this function right here :(
  -- posibbly some speedup ? need to test

  local function gaussian_mixture(value)
    local x1, x2, x3, x4, x5 = nil, nil, nil, nil, nil
    local exp = math.exp
    x1 = tmp.GAUSSIAN_V1 * exp(tmp.GAUSSIAN_S1 * (value - tmp.GAUSSIAN_N1) ^ 2)
    x2 = tmp.GAUSSIAN_V2 * exp(tmp.GAUSSIAN_S2 * (value - tmp.GAUSSIAN_N2) ^ 2)
    x3 = tmp.GAUSSIAN_V3 * exp(tmp.GAUSSIAN_S3 * (value - tmp.GAUSSIAN_N3) ^ 2)
    x4 = tmp.GAUSSIAN_V4 * exp(tmp.GAUSSIAN_S4 * (value - tmp.GAUSSIAN_N4) ^ 2)
    x5 = tmp.GAUSSIAN_V5 * exp(tmp.GAUSSIAN_S5 * (value - tmp.GAUSSIAN_N5) ^ 2)
    return x1 - x2 + x3 - x4 + x5
  end

  local norm = {} --Adsr(0.5, 0.2, 0.3, 0.4, math_buffer)
  local gauss = {}
  local pi = math.pi
  local abs = math.abs
  
  -- avoid using min/max in time critical code
  --local mx = math.max
  --local max = mx(abs(MAX_VALUE), abs(MIN_VALUE))
  local x = abs(MIN_VALUE)
  local max = nil
  
  if MAX_VALUE > x then
    max = MAX_VALUE
  else
    max = x
  end

  for i=1, #math_buffer do
  
    -- if our wave is far from ideal values then we "normalize"
    -- coz sample buffer cuts values agresive
    
    if max > 1 then
      norm[i] = math_buffer[i] / max
    else
      norm[i] = math_buffer[i]
    end

    -- Apply some envelope if needed
  
    if tmp.GAUSSIAN_ON_OFF then
      local val = norm[i]
      gauss[i] = val * gaussian_mixture(2 * pi * i / #math_buffer)
      new_buffer:set_sample_data(1,i, gauss[i])
    else
      new_buffer:set_sample_data(1,i, norm[i])
    end

  end

  new_buffer:finalize_sample_data_changes()
 
  RECALCULATE = true
  MATH_BUFFER = math_buffer
  collectgarbage("restart")

end